Tweaked our test config file to include transfer logging that
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
6f481bb0 21tmpdir="$scratchdir"
e3442095
WD
22fromdir="$tmpdir/from"
23todir="$tmpdir/to"
24chkdir="$tmpdir/chk"
3a4c683f 25
2094283b 26# Berkley's nice.
96553aa7 27PATH="$PATH:/usr/ucb"
2094283b 28
e3442095 29if diff -u "$srcdir/testsuite/rsync.fns" "$srcdir/testsuite/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
30 diffopt="-u"
31else
32 diffopt="-c"
33fi
34
a98cad00
WD
35HOME="$scratchdir"
36export HOME
37
3a4c683f
MP
38runtest() {
39 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
40 if eval "$2"
41 then
6f481bb0 42 echo "$ECHO_T done."
501972bf
MP
43 return 0
44 else
6f481bb0 45 echo "$ECHO_T failed!"
501972bf
MP
46 return 1
47 fi
3a4c683f
MP
48}
49
757287d8
WD
50# Call this if you want to filter out verbose messages (-v or -vv) from
51# the output of an rsync run (whittling the output down to just the file
52# messages). This isn't needed if you use -i without -v.
53filter_outfile() {
54 sed -e '/^building file list /d' \
55 -e '/^created directory /d' \
56 -e '/^done$/d' \
57 -e '/ --whole-file$/d' \
58 -e '/^total: /d' \
59 -e '/^$/,$d' \
60 <"$outfile" >"$outfile.new"
61 mv "$outfile.new" "$outfile"
62}
63
3a4c683f
MP
64printmsg() {
65 echo "$1"
66}
67
6773a779 68rsync_ls_lR() {
22558cdd 69 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls"
dfef3f10
MP
70}
71
18d7e9f4 72check_perms() {
eace352b
WD
73 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
74 if test $perms = $2; then
75 return 0
76 fi
77 echo "permissions: $perms on $1"
78 echo "should be: $2"
79 test_fail "failed test $3"
18d7e9f4
WD
80}
81
dfef3f10
MP
82rsync_getgroups() {
83 "$TOOLDIR/getgroups"
57835c00
MP
84}
85
86
e052b21f 87####################
6f481bb0 88# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 89
3a4c683f 90hands_setup() {
501972bf 91 # Clean before creation
6f481bb0
WD
92 rm -rf "$fromdir"
93 rm -rf "$todir"
3d807132 94
e3442095
WD
95 [ -d "$tmpdir" ] || mkdir "$tmpdir"
96 [ -d "$fromdir" ] || mkdir "$fromdir"
97 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 98
e052b21f
MP
99 # On some BSD systems, the umask affects the mode of created
100 # symlinks, even though the mode apparently has no effect on how
101 # the links behave in the future, and it cannot be changed using
102 # chmod! rsync always sets its umask to 000 so that it can
103 # accurately recreate permissions, but this script is probably run
104 # with a different umask.
105
106 # This causes a little problem that "ls -l" of the two will not be
107 # the same. So, we need to set our umask before doing any creations.
108
3a4c683f 109 # set up test data
6f481bb0
WD
110 touch "$fromdir/empty"
111 mkdir "$fromdir/emptydir"
e8ca5901 112
571a4b26 113 # a hundred lines of text or so
6f481bb0 114 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 115
6f481bb0 116 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 117 umask 0
6f481bb0 118 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 119 umask 022
0154b302 120
db10766a 121 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
122 mkdir "$fromdir/dir"
123 cp "$fromdir/text" "$fromdir/dir"
124 mkdir "$fromdir/dir/subdir"
125 echo some data > "$fromdir/dir/subdir/foobar.baz"
126 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
127 if [ -r /etc ]; then
128 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
129 else
130 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
131 fi
6f481bb0 132 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
133 if [ -r /bin ]; then
134 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
135 else
136 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
137 fi
7d691654 138
8f98c608 139# echo testing head:
6f481bb0 140# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 141}
3fedd74b
MP
142
143
99cdaff7
MP
144####################
145# Many machines do not have "mkdir -p", so we have to build up long paths.
146# How boring.
5ef8c5c6 147makepath() {
7c1b7890 148 echo " makepath $1"
99cdaff7
MP
149 p="$1"
150 (
151 # Absolut Unix.
152 if echo $p | grep '^/' >/dev/null
153 then
154 cd /
155 fi
156
157 # This will break if $1 contains a space.
158 for c in `echo $p | tr '/' ' '`
159 do
112e7311
MP
160 if [ -d "$c" ] || mkdir "$c"
161 then
162 cd "$c" || return $?
163 else
164 echo "failed to create $c" >&2; return $?
165 fi
99cdaff7
MP
166 done
167 )
168}
169
170
171
3fedd74b
MP
172###########################
173# Run a test (in '$1') then compare directories $2 and $3 to see if
174# there are any difference. If there are, explain them.
175
f494f286
MP
176# So normally basically $1 should be an rsync command, and $2 and $3
177# the source and destination directories. This is only good when you
178# expect to transfer the whole directory exactly as is. If some files
179# should be excluded, you might need to use something else.
180
3fedd74b 181checkit() {
3fedd74b 182 failed=
3fedd74b 183
cf72f204
MP
184 # We can just write everything to stdout/stderr, because the
185 # wrapper hides it unless there is a problem.
186
187 echo "Running: \"$1\""
188 eval "$1"
3fedd74b
MP
189 status=$?
190 if [ $status != 0 ]; then
191 failed="YES";
192 fi
193
cf72f204
MP
194 echo "-------------"
195 echo "check how the directory listings compare with diff:"
196 echo ""
6f481bb0
WD
197 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
198 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
199 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
200
201 echo "-------------"
202 echo "check how the files compare with diff:"
203 echo ""
204 if [ "x$4" != x ]; then
205 echo " === Skipping (as directed) ==="
206 else
207 diff -r $diffopt "$2" "$3" || failed=YES
208 fi
209
210 echo "-------------"
6f481bb0 211 if [ -z "$failed" ] ; then
3fedd74b
MP
212 return 0
213 else
3fedd74b
MP
214 return 1
215 fi
216}
217
863dff51 218
4a7cb3e8 219build_rsyncd_conf() {
d2094cc3
MP
220 # Build an appropriate configuration file
221 conf="$scratchdir/test-rsyncd.conf"
222 echo "building configuration $conf"
223
224 port=2612
225 pidfile="$scratchdir/rsyncd.pid"
226 logfile="$scratchdir/rsyncd.log"
227
6f481bb0 228 cat >"$conf" <<EOF
3aae15ec 229# rsyncd configuration file autogenerated by $0
d2094cc3 230
3aae15ec
MP
231pid file = $pidfile
232use chroot = no
233hosts allow = localhost, 127.0.0.1
234log file = $logfile
2ae4126a
WD
235log format = %i %h [%a] %m (%u) %l %f%L
236transfer logging = yes
6f481bb0 237exclude = foobar.baz
eddeaf76 238max verbosity = 9
76ee1d18
WD
239uid = 0
240gid = 0
98c1b325 241
2e6c7f45 242[test-from]
6f481bb0 243 path = $fromdir
3aae15ec 244 read only = yes
d2094cc3 245
2e6c7f45 246[test-to]
6f481bb0 247 path = $todir
3aae15ec 248 read only = no
2ae4126a
WD
249
250[test-scratch]
251 path = $scratchdir
252 read only = no
d2094cc3
MP
253EOF
254}
255
256
3cd2af41 257build_symlinks() {
3cd2af41
MP
258 mkdir "$fromdir"
259 date >"$fromdir/referent"
260 ln -s referent "$fromdir/relative"
261 ln -s "$fromdir/referent" "$fromdir/absolute"
262 ln -s nonexistent "$fromdir/dangling"
1db8b61d 263 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
264}
265
266test_fail() {
267 echo "$@" >&2
268 exit 1
269}
270
a217ad30
MP
271test_skipped() {
272 echo "$@" >&2
6f481bb0 273 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
274 exit 77
275}
276
be2f866b
MP
277# It failed, but we expected that. don't dump out error logs,
278# because most users won't want to see them. But do leave
279# the working directory around.
280test_xfail() {
281 echo "$@" >&2
282 exit 78
283}
284
d1239eae
MP
285# Determine what shell command will appropriately test for links.
286ln -s foo "$scratchdir/testlink"
287for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
288do
289 for switch in -h -L
290 do
291 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
292 then
293 # how nice
294 TEST_SYMLINK_CMD="$cmd $switch"
295 # i wonder if break 2 is portable?
296 break 2
297 fi
298 done
299done
cca4e067
MP
300# ok, now get rid of it
301rm "$scratchdir/testlink"
d1239eae
MP
302
303
304if [ "x$TEST_SYMLINK_CMD" = 'x' ]
305then
306 test_fail "Couldn't determine how to test for symlinks"
307else
308 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
309fi
310
311
d96d3893
MP
312# Test whether something is a link, allowing for shell peculiarities
313is_a_link() {
d1239eae
MP
314 # note the variable contains the first option and therefore is not quoted
315 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
316}
317
77867907
MP
318
319# We need to set the umask to be reproducible. Note also that when we
320# do some daemon tests as root, we will setuid() and therefore the
321# directory has to be writable by the nobody user in some cases. The
322# best thing is probably to explicitly chmod those directories after
323# creation.
324
ad301e48 325umask 022